#pragma once

#include <string>
#include <cstdlib>
#include <ctime>
using namespace std;

#include "opencv2/imgproc/imgproc.hpp"
#include "opencv2/highgui/highgui.hpp"
using namespace cv;

#include "Uzytki.h"
#include "PrzetwarzanieObrazow.h"

class StanMalowania {
protected:
	static const int ROZMIAR_PEDZLA = 20;
	Mat _aktualnyStan;
public:
	Vec3b kolor;
	PrzetwarzanieObrazow przetwarzanieObrazow;
	
	StanMalowania();
	double wyznaczPomalowanaCzesc();
	void uaktualnijStan(double czas, Mat obraz);
	void wyswietlStan(Mat gdzie);
};

class StanGracza {
public:
	string nazwa;
	StanMalowania stanMalowania;

	void uaktualnijStanGracza(double czas, Mat obraz);
	void wyswietlStanGracza(Mat gdzie);
};

class StanGry {
protected:
	bool _graTrwa;
	double _czasRozgrywki;
	double _pozostalyCzasGry;
	
	clock_t _rozpoczecieGry;
public:
	StanGracza gracz;

	void uaktualnijStanGry(Mat obraz);
    void wyswietlStanGry(Mat gdzie);

	void rozpocznijGre(double czasRozgrywki = 20);
	void zakonczGre();

	bool graTrwa();
};

