#include <cstdio>
using namespace std;

#include "opencv2/highgui/highgui.hpp"
using namespace cv;

#include "stany.h"

#ifdef _WIN32 
	#include <windows.h>
#elif defined  __unix__
	
#endif
int screenX, screenY;

VideoCapture kamera;
StanGry stanGry;
Mat aktualnyObraz;
Mat wyswietlanyObraz;

Mat poprawionyWyswietlanyObraz;
void wyswietlZachowujacProporcje(Mat obrazek) {
	double dodatek = (double)screenX/screenY*obrazek.rows - obrazek.cols;
	
	poprawionyWyswietlanyObraz = Mat(obrazek.rows,obrazek.cols+dodatek,obrazek.type(),Scalar_<uchar>(0));
	Mat kawalek = Mat(poprawionyWyswietlanyObraz,Range(0,obrazek.rows),Range(dodatek/2,dodatek/2+obrazek.cols));
	obrazek.copyTo(kawalek);
	imshow("Maluj plot!",poprawionyWyswietlanyObraz);
}

int main(int argc, char * argv[]) {
	kamera.open(0);
	if(!kamera.isOpened()){
		printf("Nie udalo sie zawiazac polaczenia z kamera!\n"); 
		getchar();
	}
	else {
		printf("Kamera podlaczona!\n");
		stanGry.gracz.nazwa = "Filip";

		#ifdef _WIN32 
			screenX = GetSystemMetrics(SM_CXSCREEN);
			screenY = GetSystemMetrics(SM_CYSCREEN);
		#elif defined  __unix__
			screenX = 640;
			screenY = 480;
		#endif
		
		cvNamedWindow("Maluj plot!", CV_WINDOW_NORMAL);
		cvMoveWindow("Maluj plot!", -5, -5);
		cvResizeWindow("Maluj plot!", screenX, screenY);

		stanGry.rozpocznijGre(20);

		while(waitKey(10)!=' ') {
			kamera >> aktualnyObraz;
			flip(aktualnyObraz,aktualnyObraz,1);
			stanGry.uaktualnijStanGry(aktualnyObraz);
			aktualnyObraz.copyTo(wyswietlanyObraz);
			stanGry.wyswietlStanGry(wyswietlanyObraz);
			wyswietlZachowujacProporcje(wyswietlanyObraz);
			//imshow("Maluj plot!",wyswietlanyObraz);
			if(stanGry.graTrwa() == false) break;
		}
	}
	return 0;
}
