#include "stany.h"

void StanGry::rozpocznijGre(double czasRozgrywki) {
	_rozpoczecieGry = clock();
	_czasRozgrywki = czasRozgrywki;
	_pozostalyCzasGry = czasRozgrywki;
	_graTrwa = true;
}

void StanGry::zakonczGre() {
	_graTrwa = false;
	Uzytki::dodajWpisDoWynikow(gracz.nazwa,gracz.stanMalowania.wyznaczPomalowanaCzesc());
}

bool StanGry::graTrwa() {
	return _graTrwa;
}

void StanGry::uaktualnijStanGry(Mat obraz) {
	if(_graTrwa) {
		double nowyPozostalyCzasGry = _czasRozgrywki - (double)(clock() - _rozpoczecieGry)/CLOCKS_PER_SEC;
		gracz.uaktualnijStanGracza(_pozostalyCzasGry - nowyPozostalyCzasGry,obraz);
		_pozostalyCzasGry = nowyPozostalyCzasGry;

		if(_pozostalyCzasGry < 0) zakonczGre();
	}
}

void StanGry::wyswietlStanGry(Mat gdzie) {
	if(_graTrwa) {
		gracz.wyswietlStanGracza(gdzie);
		char pozostalyCzas[20];
		sprintf(pozostalyCzas,"%.2lf s.", _pozostalyCzasGry);
		Uzytki::wypiszTekst(gdzie,pozostalyCzas,Point(0,gdzie.rows-20));
	}
}

void StanGry::wyswietlNajlepszych(Mat gdzie) {
	vector< pair<double,string> > wyniki = Uzytki::wczytajWyniki();
	Uzytki::wypiszTekst(gdzie,"Najlepsi malarze:",Point(100, 50));
	for(int i=0;i<min(5,(int)wyniki.size());i++) {
		char tekst[200];
		sprintf(tekst,"%d. %s - %s%%",i+1,wyniki[i].second.c_str(),Uzytki::ftos(wyniki[i].first*100,2).c_str());
		Uzytki::wypiszTekst(gdzie,tekst,Point(100, 100 + 50*i ));
	}
}
