#include "Uzytki.h"

void Uzytki::wypiszTekst(Mat gdzie, String tekst, Point polozenie) {
	putText(gdzie, tekst, polozenie, CV_FONT_HERSHEY_SIMPLEX, 1, cvScalar(0, 255, 0, 0),3);
}

string Uzytki::ftos(double liczba, int dokladnosc) {
	char znacznik[10];
	sprintf(znacznik,"%%.%dlf",dokladnosc);
	char wynik[20];
	sprintf(wynik,znacznik,liczba);
	return wynik;
}

long long Uzytki:: wyliczSumeKontrolna (string tekst) {
	long long suma = 1;
	for(int i=0;i<tekst.size();i++) suma = (suma * tekst[i]) % 10000019;
	return suma;
}

vector<pair<double,string> > Uzytki::wczytajWyniki(string sciezka) {
	vector< pair<double,string> > wyniki;
	FILE * plik = fopen(sciezka.c_str(),"r");
	if(plik != NULL) {
		int ileWynikow;
		fscanf(plik,"%d\n",&ileWynikow);
		long long sumaKontrolna = 0;
		char bufor[1000]; 
		for(int i=0;i<ileWynikow;i++) {
			fgets(bufor,1000,plik);
			sumaKontrolna += wyliczSumeKontrolna(bufor);

			char nazwaGracza[100];
			double wynikGracza;
			sscanf(bufor,"%s %lf",nazwaGracza,&wynikGracza);
			wyniki.push_back(make_pair(wynikGracza,nazwaGracza));
		}
		sumaKontrolna %= 10000019;
		int zapisanaSumaKontrolna;
		fscanf(plik,"%d",&zapisanaSumaKontrolna);
		if(sumaKontrolna == zapisanaSumaKontrolna) {
			sort(wyniki.begin(),wyniki.end(), greater< pair<double,string> >());
		}
		else {
			wyniki.clear();
		}
		fclose(plik);
	}
	return wyniki;
}	


void Uzytki::dodajWpisDoWynikow(string nazwaGracza, double nowyWynikGracza, string sciezka) {
	vector< pair<double,string> > wyniki = wczytajWyniki(sciezka);
	wyniki.push_back(make_pair(nowyWynikGracza,nazwaGracza));
	FILE * plik = fopen(sciezka.c_str(),"w");
	fprintf(plik,"%d\n",wyniki.size());
	long long sumaKontrolna = 0;
	for(int i=0;i<wyniki.size();i++) {
		char bufor[1000];
		sprintf(bufor,"%s %lf\n",wyniki[i].second.c_str(),wyniki[i].first);
		sumaKontrolna += wyliczSumeKontrolna(bufor);
		fputs(bufor,plik);
	}
	sumaKontrolna %= 10000019;
	fprintf(plik,"%d\n",sumaKontrolna);
	fclose(plik);
}
