#include "stany.h"

void StanGry::rozpocznijGre(double czasRozgrywki) {
	_rozpoczecieGry = clock();
	_czasRozgrywki = czasRozgrywki;
	_pozostalyCzasGry = czasRozgrywki;
	_graTrwa = true;
	_liczbaGraczy = gracze[1].nazwa.size() != 0 ? 2 : 1;
}

void StanGry::zakonczGre() {
	_graTrwa = false;
	Uzytki::dodajWpisDoWynikow(gracze[0].nazwa,gracze[0].stanMalowania.wyznaczPomalowanaCzesc());
	if(_liczbaGraczy==2) Uzytki::dodajWpisDoWynikow(gracze[1].nazwa,gracze[1].stanMalowania.wyznaczPomalowanaCzesc());
}

bool StanGry::graTrwa() {
	return _graTrwa;
}

void StanGry::uaktualnijStanGry(Mat obraz) {
	if(_graTrwa) {
		double nowyPozostalyCzasGry = _czasRozgrywki - (double)(clock() - _rozpoczecieGry)/CLOCKS_PER_SEC;
		gracze[0].uaktualnijStanGracza(_pozostalyCzasGry - nowyPozostalyCzasGry,oknoGracza1(obraz));
		if(_liczbaGraczy==2) gracze[1].uaktualnijStanGracza(_pozostalyCzasGry - nowyPozostalyCzasGry,oknoGracza2(obraz));
		_pozostalyCzasGry = nowyPozostalyCzasGry;

		if(_pozostalyCzasGry < 0) zakonczGre();
	}
}

void StanGry::wyswietlStanGry(Mat gdzie) {
	if(_graTrwa) {
		gracze[0].wyswietlStanGracza(oknoGracza1(gdzie));
		if(_liczbaGraczy==2) gracze[1].wyswietlStanGracza(oknoGracza2(gdzie));
		char pozostalyCzas[20];
		sprintf(pozostalyCzas,"%.2lf s.", _pozostalyCzasGry);
		Uzytki::wypiszTekst(gdzie,pozostalyCzas,Point(0,gdzie.rows-20));
	}
}

void StanGry::wyswietlNajlepszych(Mat gdzie) {
	vector< pair<double,string> > wyniki = Uzytki::wczytajWyniki();
	Uzytki::wypiszTekst(gdzie,"Najlepsi malarze:",Point(100, 50));
	for(int i=0;i<min(5,(int)wyniki.size());i++) {
		char tekst[200];
		sprintf(tekst,"%d. %s - %s%%",i+1,wyniki[i].second.c_str(),Uzytki::ftos(wyniki[i].first*100,2).c_str());
		Uzytki::wypiszTekst(gdzie,tekst,Point(100, 100 + 50*i ));
	}
}

Mat StanGry::oknoGracza1(Mat obraz) {
	if(_liczbaGraczy == 1) return obraz;
	else return Mat(obraz,Range(0,obraz.rows),Range(0,obraz.cols/2));
}

Mat StanGry::oknoGracza2(Mat obraz) {
	return Mat(obraz,Range(0,obraz.rows),Range(obraz.cols/2,obraz.cols));
}
