#include "Stany.h"

StanMalowania::StanMalowania() {
	kolor = Vec3b(0,0,255);
	_zarysPlotu = imread("plot.png",0); 
}

double StanMalowania::wyznaczPomalowanaCzesc() {
	return (double)cv::countNonZero(_aktualnyStan)/cv::countNonZero(_zarysPlotu);
}

void StanMalowania::uaktualnijStan(double czas, Mat obraz) {
	if(_aktualnyStan.data==NULL) {
		_aktualnyStan = Mat(obraz.size(),CV_8U,Scalar(0));
		resize(_zarysPlotu,_zarysPlotu,_aktualnyStan.size());
	}
	Point polozenie = przetwarzanieObrazow.polozeniePedzla(obraz);
	if(polozenie.x>0) {
		circle(_aktualnyStan,polozenie,ROZMIAR_PEDZLA,255,-1);
		bitwise_and(_aktualnyStan, _zarysPlotu, _aktualnyStan);
	}
}

void StanMalowania::wyswietlStan(Mat gdzie) {
	if(_aktualnyStan.data!=NULL) {
		gdzie.setTo(Vec3b(100,100,100),_zarysPlotu);
		gdzie.setTo(kolor,_aktualnyStan);
	}
}

